package org.eclipse.equinox.weaving.hello.aspects;

import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.eclipse.equinox.weaving.demo.hello.internal.Initializable;

@Aspect
public class TestAspect {
	
    @AfterReturning(pointcut="call(org.eclipse.equinox.weaving.demo.hello.internal.Initializable+.new(..))",returning="initializable")
    public void anotherConstruct(Initializable initializable) {
    	if( initializable != null) {
            System.out.println("After Initializable Constructor from class : "+initializable.getClass().getSimpleName());
            // TODO Fix this : Crashes if following line is enabled
           initializable.initialize();
    	} else {
            System.out.println("After Non-Initializable Constructor");
    	}
    }
	
	
	@Before("execution(* org.eclipse.equinox.weaving.demo..greet(..))")
	public void checkIt() {
        System.out.println("Before greet ;-)");
	}
	
}
